using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Sales.DeliveryOrder.Cqrs;

public class UpdateDeliveryOrderItemRequest
{
    public string? Id { get; set; }
    public string? WarehouseId { get; set; }
    public string? ProductId { get; set; }
    public double? Movement { get; set; }
}

public record UpdateDeliveryOrderItemCommand(UpdateDeliveryOrderItemRequest Data) : IRequest<bool>;

public class UpdateDeliveryOrderItemHandler : IRequestHandler<UpdateDeliveryOrderItemCommand, bool>
{
    private readonly AppDbContext _context;
    public UpdateDeliveryOrderItemHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(UpdateDeliveryOrderItemCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.InventoryTransaction
            .FirstOrDefaultAsync(x => x.Id == request.Data.Id, cancellationToken);

        if (entity == null) return false;

        entity.WarehouseId = request.Data.WarehouseId;
        entity.ProductId = request.Data.ProductId;
        entity.Movement = request.Data.Movement;

        _context.CalculateInvenTrans(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}